# -*- coding: utf-8 -*-

__package__ = "cifrado"
__version__ = "0.6.1.2"
__description__ = "Chiffrer et imprimer les messages de grand-jeu"
__website__ = "http://cifrado.free.fr/"
__pythondir__ = "/usr/local/lib/python2.6/dist-packages/cifrado"
__datadir__ = "/usr/local/share"
__gettext_package__ = "cifrado"
__localedir__ = "/usr/local/share/locale"

import  os.path
import  gettext
_ = gettext.gettext

__ui__ = os.path.join(os.path.dirname(__file__), 'cifrado.ui')


COL_FORCE,      COL_FOR_NOM,  COL_FOR_ACT, COL_FOR_CHEF, COL_FOR_CLEF, COL_FOR_POL   = range(6)
COL_LIEU,       COL_LIEU_NOM                                            = range(2)
COL_SUB_VAR,    COL_SUB_VAL                                             = range(2)
COL_MSG,        COL_MSG_EXP,    COL_MSG_TITRE,  COL_MSG_DATE            = range(4)
COL_ETAPE,      COL_ET_DATE,    COL_ET_TITRE,   COL_ET_LIEU             = range(4)
COL_ITEM                                                                = 0
# codeur dispo
COL_COD_CLASSE, COL_COD_NOM                                             = range(2)
# chaine de codage
COL_COD,        COL_COD_NOM,    COL_COD_PROP                            = range(3)
# carte
COL_CALQUE,     COL_CALQUE_NOM, COL_CALQUE_COUL                         = range(3)
COL_POS,        COL_POS_POSER,  COL_POS_NOM,    COL_POS_PICTO           = range(4)

import  gobject
import  gtk
from    .       import  codeurs as CODEURS

# CODEURS existant
codeurs_classes = {}
codeurs = gtk.ListStore(gobject.TYPE_PYOBJECT,
                        gobject.TYPE_STRING)

# chargement des codeurs
for m in CODEURS.__all__: # pas très dynamique
    try:
        m = m.strip()
        module = __import__('codeurs.'+m, globals(), locals(), ['codeurs.'+m], -1)
        codeurs_classes[module.Codeur.nom] = module.Codeur
        module.iter = codeurs.append([module.Codeur, module.Codeur.nom])
    except:
        print "Codeur %s inexistant."%(m)

# traducteurs: Nom des variables prédéfinie. Veillez à garder le $ et
# n'utiliser que des majuscules !
prevars = [_('$FORCE'), _('$CHEF'), _('$CLEF')]
